>>>>>>>>>>>>>>>
Since this is NOT the main program, So I cannot annotate calls that you missed.

You need to make the following call in your utemerge so you don't need to 
have file SLOG_Preview.txt in the working directory

SLOG_SetPreviewName( slog, "/dev/null" );

which can be put it after, for instance, SLOG_SetIncreasingEndtimeOrder().
i.e. during the initialization of slog.
<<<<<<<<<<<<<<<
/*
 * NOTE:
 * CURRENTLY SLOG_API DOES NOT SUPPORT 'WHERE'
 * TURNING OFF -DNOWHERE CAUSES DISASTROUS RESULTS
 *
 * slogmerge: takes multiple UTE interval files, and creates an output file
 */
#include <stdio.h>
#include <math.h>
#include <sys/trchkid.h>
#include <values.h>
#include "mpitrcev.h"
#include "uteheader.h"
#include "event_define.h"
#include "slog.h"
#include "aix2ute.h"

typedef union {
  double dbl;
  int uint[2];
} dblint;

extern char taskbit[];
extern char threadTypeBit[];

/*
 * the following 3 variables are defined in utemerge.c
 */
extern dblint MINDIFF;
extern int max_num_markers;
extern table_format etable;
extern aixargs b_aix[];
extern aixargs e_aix[];

#define MILLION 1000000
#define ADDBYTES (MINBYTES+4)

static double end_time = 0.0;

double check_doubles(double s, double d) {
  double end, diff, min;
  int *ip, *jp;

  end = s+d;
  if (end + MINDIFF.dbl < end_time) {
    diff = end_time - end;
    fprintf(stderr,
      "Warning: end time %.18lf < last end time %.18lf := %.18lf\n",
      end, end_time, diff);
    min = MINDIFF.dbl;
    fprintf(stderr,"diff = %.18lf; min = %.18lf\n", diff, min);
    exit(4);
  } else if (end < end_time) {
    return(end_time - d);
  } else {
    end_time = end;
    return(s);
  }
}

/*
 * SLOG Argument array
 */
SLOG_arg_t irec_args[10];
SLOG_uint32 irec_Nargs;

slog_append_rec(SLOG_STREAM *slog, unsigned ev, unsigned be, long long *s, 
long long *d, unsigned nodeid, unsigned cpuid, unsigned tid, unsigned w, UTENODE *ptr) {
  SLOG_rectype_t rectype;
  SLOG_intvltype_t etype;
  SLOG_starttime_t stime;
  SLOG_duration_t duration;
  SLOG_bebit_t bbit;
  SLOG_bebit_t ebit;
  SLOG_nodeID_t node;
  SLOG_cpuID_t cpu;
  SLOG_threadID_t thread;
  SLOG_where_t where;
  SLOG_assoc_t assoc;
  SLOG_intvlrec_t *irec;
  long long ilong, lastEnd = 0;
  int i, j;

>>>>>>>>>>
  rectype = 100;
----------
  rectype = SLOG_RECTYPE_STATIC_DIAG;
<<<<<<<<<<
  etype = ev;

  ilong = *s + *d;
  if (ilong < lastEnd) {
    fprintf(stderr,"Error: end time %lld < last end time %lld\n",ilong,lastEnd);
    exit(3);
  } else
    lastEnd = ilong;
  ilong = *s;
  stime = (double) ilong /MILLION;
  ilong = *d;
  duration = (double) ilong / MILLION;
  stime = check_doubles(stime, duration);

  node = nodeid;
  cpu = cpuid;
  thread = tid;
  where = w;
  assoc = 0;

  if ((irec = SLOG_Irec_Create()) == (SLOG_intvlrec_t *)SLOG_FAIL) {
    fprintf(stderr,"Error: SLOG_Irec_Create() failed\n");
    exit(0);
  }
  if ( SLOG_Irec_SetMinRec( irec, rectype, etype, be >> 1, be & 0x01,
    stime, duration, node, cpu, thread, where ) == SLOG_FAIL) {
    fprintf(stderr,"Error: SLOG_Irec_SetMinRec() failed\n");
    exit(0);
  }

/*
 * Irec_SetArgs
 */
  irec_Nargs = 0;
  if (ev >= NUM_ENTRIES) {
    fprintf(stderr,"Error: event type %d unknown\n", ev);
    exit(2);
  }
  switch(ev) {
  case _SEND:
  case _BSEND:
  case _RSEND:
  case _SSEND:
    switch(be) {
    case BE_BEBIT:
      irec_Nargs = 6;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      irec_args[4] = *(int *)&(ptr->Eventbuf[ADDBYTES+16]);
      irec_args[5] = *(int *)&(ptr->Eventbuf[ADDBYTES+20]);
      break;
    case E_BEBIT:
      irec_Nargs = 4;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      break;
    case B_BEBIT:
      irec_Nargs = 2;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      break;
    }
    break;
  case _ISEND:
  case _IBSEND:
  case _IRSEND:
  case _ISSEND:
    switch(be) {
    case BE_BEBIT:
      irec_Nargs = 7;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      irec_args[4] = *(int *)&(ptr->Eventbuf[ADDBYTES+16]);
      irec_args[5] = *(int *)&(ptr->Eventbuf[ADDBYTES+20]);
      irec_args[6] = *(int *)&(ptr->Eventbuf[ADDBYTES+24]);
      break;
    case E_BEBIT:
      irec_Nargs = 5;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      irec_args[4] = *(int *)&(ptr->Eventbuf[ADDBYTES+16]);
      break;
    case B_BEBIT:
      irec_Nargs = 2;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      break;
    }
    break;
  case _RECV:
    switch(be) {
    case BE_BEBIT:
    case E_BEBIT:
      irec_Nargs = 5;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      irec_args[4] = *(int *)&(ptr->Eventbuf[ADDBYTES+16]);
      break;
    }
    break;
  case _IRECV:
    switch(be) {
    case BE_BEBIT:
      irec_Nargs = 5;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      irec_args[4] = *(int *)&(ptr->Eventbuf[ADDBYTES+16]);
      break;
    case E_BEBIT:
      irec_Nargs = 3;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      break;
    case B_BEBIT:
      irec_Nargs = 2;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      break;
    }
    break;
  case _SENDRECV:
    switch(be) {
    case BE_BEBIT:
      irec_Nargs = 9;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      irec_args[4] = *(int *)&(ptr->Eventbuf[ADDBYTES+16]);
      irec_args[5] = *(int *)&(ptr->Eventbuf[ADDBYTES+20]);
      irec_args[6] = *(int *)&(ptr->Eventbuf[ADDBYTES+24]);
      irec_args[7] = *(int *)&(ptr->Eventbuf[ADDBYTES+28]);
      irec_args[8] = *(int *)&(ptr->Eventbuf[ADDBYTES+32]);
      break;
    case E_BEBIT:
      irec_Nargs = 7;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      irec_args[4] = *(int *)&(ptr->Eventbuf[ADDBYTES+16]);
      irec_args[5] = *(int *)&(ptr->Eventbuf[ADDBYTES+20]);
      irec_args[6] = *(int *)&(ptr->Eventbuf[ADDBYTES+24]);
      break;
    case B_BEBIT:
      irec_Nargs = 2;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      break;
    }
    break;
  case _SENDRECV_REPLACE:
    switch(be) {
    case BE_BEBIT:
      irec_Nargs = 8;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      irec_args[4] = *(int *)&(ptr->Eventbuf[ADDBYTES+16]);
      irec_args[5] = *(int *)&(ptr->Eventbuf[ADDBYTES+20]);
      irec_args[6] = *(int *)&(ptr->Eventbuf[ADDBYTES+24]);
      irec_args[7] = *(int *)&(ptr->Eventbuf[ADDBYTES+28]);
      break;
    case E_BEBIT:
      irec_Nargs = 6;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      irec_args[2] = *(int *)&(ptr->Eventbuf[ADDBYTES+8]);
      irec_args[3] = *(int *)&(ptr->Eventbuf[ADDBYTES+12]);
      irec_args[4] = *(int *)&(ptr->Eventbuf[ADDBYTES+16]);
      irec_args[5] = *(int *)&(ptr->Eventbuf[ADDBYTES+20]);
      break;
    case B_BEBIT:
      irec_Nargs = 2;
      irec_args[0] = *(int *)&(ptr->Eventbuf[ADDBYTES]);
      irec_args[1] = *(int *)&(ptr->Eventbuf[ADDBYTES+4]);
      break;
    }
    break;
  case _UTE_VERSION:
  case _TRCON:
  case _TB0_CLOCK:
  case _RUNNING:
  case _WAITALL_INFO:
  case _TESTALL_INFO_HDR:
  case _TESTALL_INFO:
  case _WAITSOME_INFO_HDR:
  case _WAITSOME_INFO:
  case _TESTSOME_INFO_HDR:
  case _TESTSOME_INFO:
  case _STARTALL_B_INFO:
  case _STARTALL_E_INFO:
  case _START_REQUEST:
  case _NEW_COMM_ID:
  case _NEW_COMM_RANKS:
  case _ENV_VARS:
  case _MPI_FAILURE:
  case _TRACE_TERMINATED:
  case _THREAD_IDS:
    switch(be) {
    case B_BEBIT:
      j = b_aix[ev].nargs;
      irec_Nargs = j;
      for (i = 0; i < j; i++) 
        irec_args[i] = *(int *)&(ptr->Eventbuf[MINBYTES+i*4]);
      break;
    case E_BEBIT:
      j = e_aix[ev].nargs ;
      irec_Nargs = j;
      for (i = 0; i < j; i++)
        irec_args[i] = *(int *)&(ptr->Eventbuf[MINBYTES+i*4]);
      break;
    case BE_BEBIT:
      j = b_aix[ev].nargs + e_aix[ev].nargs ;
      irec_Nargs = j;
      for (i = 0; i < j; i++)
        irec_args[i] = *(int *)&(ptr->Eventbuf[MINBYTES+i*4]);
      break;
    case CON_BEBIT:
      irec_Nargs = 0;
      break;
    }
    break;
  default:
    switch(be) {
    case B_BEBIT:
      j = b_aix[ev].nargs;
      irec_Nargs = j;
      for (i = 0; i < j; i++) 
        irec_args[i] = *(int *)&(ptr->Eventbuf[ADDBYTES+i*4]);
      break;
    case E_BEBIT:
      j = e_aix[ev].nargs ;
      irec_Nargs = j;
      for (i = 0; i < j; i++)
        irec_args[i] = *(int *)&(ptr->Eventbuf[ADDBYTES+i*4]);
      break;
    case BE_BEBIT:
      j = b_aix[ev].nargs + e_aix[ev].nargs ;
      irec_Nargs = j;
      for (i = 0; i < j; i++)
        irec_args[i] = *(int *)&(ptr->Eventbuf[ADDBYTES+i*4]);
      break;
    case CON_BEBIT:
      irec_Nargs = 0;
      break;
    }
    break;
  }
  if (irec_Nargs > 0)
    SLOG_Irec_SetArgs( irec, slog, irec_Nargs, irec_args );

  if ( SLOG_Irec_ToOutputStream( slog, irec ) == SLOG_FAIL ) {
    fprintf(stderr,"Error: SLOG_Irec_ToOutputStream() failed\n");
    exit(0);
  }
  SLOG_Irec_Free( irec );

}

add_profile(SLOG_STREAM *slogstr) {
  int i, j, k;

  if (SLOG_PROF_Open(slogstr) == SLOG_FAIL) {
    fprintf(stderr, "Error: SLOG_PROF_Open() failed\n");
    exit(0);
  }
  for (i = 0; i < _RUNNING + 1; i++) {
/*
    fprintf(stderr, "index=%d, %s\n", i,
      etable.record_names.name_array[etable.row[i<<2].name_index]);
*/
    switch (i) {
>>>>>>>>>>>
    case _RUNNING:
      if ((j = SLOG_PROF_AddIntvlInfo(slogstr, i, "Program_state", 
        etable.record_names.name_array[etable.row[i<<2].name_index], 
        getRandomColorName())) == SLOG_FAIL) {
      fprintf(stderr, "Error: SLOG_PROF_AddIntvlInfo() failed for type=%d\n",i);
         exit(0);
      }
      break;
-----------
    /*
       The SLOG_PROF_AddIntvlInfo() interface has been changed to

       int SLOG_PROF_AddIntvlInfo(       SLOG_STREAM      *slog,
                                   const SLOG_intvltype_t  intvltype,
                                   const SLOG_bebit_t      bebit_0,
                                   const SLOG_bebit_t      bebit_1,
                                   const char *            classtype,
                                   const char *            label,
                                   const char *            color,
                                   const SLOG_N_args_t     Nargs,
                                         ... );

       Notice the addition of 2 bebits argument, bebit_0 & bebit_1.  So you
       needs to add the 4 different bebits arguments after argument "i" in
       SLOG_PROF_AddIntvlInfo().   Also, there are extra arguments, Nargs,
       and a variable list of strings.  For most intervals which don't have
       arguments, Nargs needs to be set to zero.   So in above 
       SLOG_PROF_AddIntvlInfo() call, you need to add an extra argument, 0, 
       after "getRandomColorName()".
    */
<<<<<<<<<<<
    case _TB0_CLOCK:
    case _START_REQUEST:
    case _NEW_COMM_ID:
    case _NEW_COMM_RANKS:
    case _ENV_VARS:
    case _WAITALL_INFO:
    case _TESTALL_INFO:
    case _TESTALL_INFO_HDR:
    case _TESTSOME_INFO_HDR:
    case _TESTSOME_INFO:
    case _STARTALL_B_INFO:
    case _STARTALL_E_INFO:
    case _USER_MARKER_DEF:
    case _MPI_FAILURE:
    case _TRACE_TERMINATED:
    case _THREAD_IDS:
>>>>>>>>>>>
    case _UTE_VERSION:
      if ((j = SLOG_PROF_AddIntvlInfo(slogstr, i, "Event_state", 
        etable.record_names.name_array[etable.row[i<<2].name_index], 
        getRandomColorName())) == SLOG_FAIL) {
      fprintf(stderr, "Error: SLOG_PROF_AddIntvlInfo() failed for type=%d\n",i);
         exit(0);
      }
      break;
    default:
      if ((j = SLOG_PROF_AddIntvlInfo(slogstr, i, "MPI_state", 
        etable.record_names.name_array[etable.row[i<<2].name_index], 
        getRandomColorName())) == SLOG_FAIL) {
      fprintf(stderr, "Error: SLOG_PROF_AddIntvlInfo() failed for type=%d\n",i);
         exit(0);
      }
      break;
-----------
    /*
    Do changes to "Event_state" like what did before.

    Needs to do something like what you did in add_defs() for those "MPI_state"
    which have extra arguments.   For example, you __may__ need to have

      case _RSEND:
        switch(i) {                      ! for 4 different bebits
        case B_BEBIT:
          SLOG_RDEF_AddIntvlInfo(slogstr, itype4rsend, i >> 1, i & 0x1, 
                                 "MPI_state", "RSEND", getRandomColorName(),
                                 1,
                                 "rsend_b_tag1" );
          break;
        case E_BEBIT:
          SLOG_RDEF_AddIntvlInfo(slogstr, itype4rsend, i >> 1, i & 0x1, 
                                 "MPI_state", "RSEND", getRandomColorName(),
                                 2,
                                 "rsend_e_tag1", "rsend_e_tag2" );
          break;
        case BE_BEBIT:
          SLOG_RDEF_AddIntvlInfo(slogstr, itype4rsend, i >> 1, i & 0x1,
                                 "MPI_state", "RSEND", getRandomColorName(),
                                 3,
                                 "rsend_b_tag1",
                                 "rsend_e_tag1", "rsend_e_tag2");
          break;
        default:
          SLOG_RDEF_AddIntvlInfo(slogstr, itype4rsend, i >> 1, i & 0x1,
                                 "MPI_state", "RSEND", getRandomColorName(),
                                 0);
          break;
        }
        break;
         
    */
<<<<<<<<<<<
    }
  }
  if ((i = SLOG_PROF_SetExtraNumOfIntvlInfos(slogstr, 
    max_num_markers)) == SLOG_FAIL) {
    fprintf(stderr, "Error: SLOG_PROF_SetExtraNumIntvlInfos() failed\n");
    exit(0);
  }

/*
 * cannot call SLOG_PROF_Close()
 *
  if ((i = SLOG_PROF_Close(slogstr)) == SLOG_FAIL) {
    fprintf(stderr, "Error: SLOG_PROF_Close() failed\n");
    exit(0);
  }
 */
}

add_defs(SLOG_STREAM *slogstr) {
  int i, j, k;
  SLOG_intvltype_t rectype;
  int be;
  SLOG_N_assocs_t nassoc;
  SLOG_N_args_t nargs;

  if (SLOG_RDEF_Open(slogstr) == SLOG_FAIL) {
    fprintf(stderr, "Error: SLOG_RDEF_Open() failed\n");
    exit(0);
  }
  for (rectype = 0; rectype < _RUNNING+1; rectype++) {
    for (i = 0; i < 4; i++) {
      switch(rectype) {
      case _ISEND:
      case _IBSEND:
      case _ISSEND:
      case _IRSEND:
        switch(i) {
        case BE_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 7);
          break;
        case E_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 5);
          break;
        case B_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 2);
          break;
        default:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 0);
          break;
        }
        break;
      case _SEND:
      case _BSEND:
      case _SSEND:
      case _RSEND:
        switch(i) {
        case BE_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 6);
          break;
        case E_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 4);
          break;
        case B_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 2);
          break;
        default:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 0);
          break;
        }
        break;
      case _SENDRECV:
        switch(i) {
        case BE_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 9);
          break;
        case E_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 7);
          break;
        case B_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 2);
          break;
        default:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 0);
          break;
        }
        break;
      case _SENDRECV_REPLACE:
        switch(i) {
        case BE_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 8);
          break;
        case E_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 6);
          break;
        case B_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 2);
          break;
        default:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 0);
          break;
        }
        break;
      case _RECV:
        switch(i) {
        case BE_BEBIT:
        case E_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 5);
          break;
        default:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 0);
          break;
        }
        break;
      case _IRECV:
        switch(i) {
        case BE_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 5);
          break;
        case E_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 3);
          break;
        case B_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 2);
          break;
        default:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 0);
          break;
        }
        break;
      case _USER_MARKER_INTERVAL:
        SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 0);
        break;
      default:
        switch(i) {
        case B_BEBIT:
          j = b_aix[rectype].nargs;
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, j);
          break;
        case E_BEBIT:
          j = e_aix[rectype].nargs ;
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, j);
          break;
        case BE_BEBIT:
          j = b_aix[rectype].nargs + e_aix[rectype].nargs ;
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, j);
          break;
        case CON_BEBIT:
          SLOG_RDEF_AddRecDef(slogstr, rectype, i >> 1, i & 0x1, 0, 0);
          break;
        }
        break;
      }
    }
  }
  if ((i = SLOG_RDEF_SetExtraNumOfRecDefs( 
    slogstr, 4 * max_num_markers)) == SLOG_FAIL) {
    fprintf(stderr, "Error: SLOG_RDEF_SetExtraNumOfRecDefs() failed\n");
    exit(0);
  }

/*
 * cannot call SLOG_RDEF_Close() as its document says
 *
  if ((i = SLOG_RDEF_Close(slogstr)) == SLOG_FAIL) {
    fprintf(stderr, "Error: SLOG_RDEF_Close() failed\n");
    exit(0);
  }
 */
}

int add_ttab(SLOG_STREAM *slogstr, UTENODE *uten, int nnodes) {
  int i, j, k;
  int ttype;
  SLOG_nodeID_t nodeid;
  SLOG_threadID_t tid;
  SLOG_OSprocessID_t ospid;
  SLOG_OSthreadID_t ostid;
  SLOG_appID_t appid;
  UTENODE *ptr;

  if (SLOG_TTAB_Open(slogstr) == SLOG_FAIL) {
    fprintf(stderr, "Error: SLOG_TTAB_Open() failed\n");
    exit(0);
  }
  k = 0;
  for (i = 0; i < nnodes; i++) {
    ptr = &uten[i];
    for (j = 0; j < MAX_THREADS_PER_NODE; j++) {
      if (ptr->head->logicthd[j].taskid != -1) {
        if (k < MAX_THREADS) {
          appid = ptr->head->logicthd[j].taskid;
          nodeid = ptr->head->logicthd[j].nodeid;
          tid = ptr->head->logicthd[j].ltid;
          ospid = ptr->head->logicthd[j].processid;
          ostid = ptr->head->logicthd[j].threadid;
          ttype = ptr->head->logicthd[j].threadType;
          if (ISBITSET(taskbit, appid) && ISBITSET(threadTypeBit, ttype)) {
            ptr->head->logicthd[j].selectMask = 0;
            if (SLOG_TTAB_AddThreadInfo(slogstr, 
              nodeid, tid, ospid, ostid, appid) == SLOG_FAIL) {
              fprintf(stderr, "Error: SLOG_TTAB_AddThreadInfo() failed\n");
              exit(0);
            }
          } else
            ptr->head->logicthd[j].selectMask = 1;
        }
        k++;
      }
    }
  }
  if ((i = SLOG_TTAB_Close(slogstr)) == SLOG_FAIL) {
    fprintf(stderr, "Error: SLOG_TTAB_Close() failed\n");
    exit(0);
  }
  return k;
}

